require_relative "svg/svg_components"
require "prawn-svg"
module TeachingPrintables
  # Creates quadrille rulings on paper.  Delegates Prawn methods to Prawn::Document.

  module QuadRulable
    # Make quadrille rules 
    
    attr_accessor :rule_unit
    
    def rule_unit
      @rule_unit ||= 1.cm
    end
    def rule_height
      bounds.top - bounds.bottom
    end
    def rule_width 
      bounds.right - bounds.left
    end
  
    def create_quad_rule(options={})
      parse_options(options)
      puts rule_unit
      ncols = (rule_width.to_f/rule_unit).ceil
      nrows = (rule_height.to_f/rule_unit).ceil
      
     
      #Create svg grid with 10pxX10px unit square.  
      #str = SVGComponents::header(@width,@height)
      str = SVGComponents::quad_ruled_grid(nrows,ncols)  
      #str << SVGComponents::footer
    
      if (page_number ==0) || (options[:start_new_page] == true)
        start_new_page
      end
      
      svg(str,width: ncols*rule_unit, height: nrows*rule_unit, at:[0,rule_height]) #position: :center, vposition: :center)
      
    end
    
    private
    def parse_options(options)
      allowed_parameters = [:rule_unit]
      options.each do |k,v|
        puts "@#{k.to_s}"
        instance_variable_set("@#{k.to_s}",v) if allowed_parameters.include?(k)
      end
    end
  end
end