require_relative 'svg_components'

class SVGCreator
  # Use SVGCreator to add svg components to an array
  # Method 'svg' concatenates the array elements, adds header and footer, and returns svg string
  
  def initialize(width,height)
    @width = width
    @height = height
    @components = []
  end
  
  def svg
    @components.insert(0,SVGComponents::header(@width,@height))
    @components << SVGComponents::footer
    return @components.join
  end
  
  
  SVGComponents.methods(false).each do |name|
    define_method("add_#{name}") do |options = {}|
      if options
        if SVGComponents.respond_to?(name)
          @components << SVGComponents.send(name,options)
        else
          false
        end
      end
    end
  end
  
end

