require_relative "./utilities"
require_relative "./gridable"

module TeachingPrintables
  # Creates grid layouts for flashcards or math sheets.  Delegates Prawn methods to Prawn::Document.

  module Templatable
    include Gridable
   
    PRINT_TEMPLATES = {
      compulabel: {
        :page_layout => :portrait, 
        :page_size => "LETTER",
        :top_margin => 0.25.in,
        :bottom_margin => 0.25.in,
        :right_margin => 0.in,
        :left_margin => 0.in,
        :columns => 3,
        :rows => 7,
        :gutter => 10
      },

      avery5371: {
        :page_layout => :portrait, 
        :page_size => "LETTER",
        :top_margin => 0.5.in,
        :bottom_margin => 0.5.in,
        :right_margin => 0.75.in,
        :left_margin => 0.75.in,
        :columns => 2,
        :rows => 5,
        :gutter => 0
      }
    }
    
    def create_page_with_template(template)
      start_new_page(PRINT_TEMPLATES[template])
      update_grid_options(PRINT_TEMPLATES[template])
    end
  end
end
    